//	Copyright (c) 2002 Midikyou

/*
 *	_OEXe[g̐ݒ
 *
 *	pram	: p[^
 *	state	: 
 */
inline void devSetState(D3DRENDERSTATETYPE pram, DWORD state){
	sv3.pDev->SetRenderState(pram, state);
}

/*
 *	_OEXe[g̎擾
 *
 *	pram	: p[^
 */
inline DWORD devGetState(D3DRENDERSTATETYPE pram){
	DWORD state;
	sv3.pDev->GetRenderState(pram, &state);
	return state;
}

/*
 *	ϊs񃊃Zbg
 */
inline void devResetMatrix(){
	devTransform(&sv3.mtxFront);
}

/*
 *	Cg̎gp
 *
 *	f	: TRUECeBOLAFALSE
 */
inline void devSetLighting(BOOL f){
	devSetState(D3DRS_LIGHTING, f);
}
inline BOOL devGetLighting(){
	return (BOOL)devGetState(D3DRS_LIGHTING);
}

/*
 *	Cgiʁĵnm^nee
 *
 *	n	: CfbNX
 *	f	: ^l
 */
inline void devSetLight(int n, BOOL f){
	sv3.pDev->LightEnable(n, f);
}

/*
 *	ArGgJ[
 */
inline void devSetAmbient(D3DCOLOR c){
	devSetState(D3DRS_AMBIENT, c);
}

/*
 *	}eA̐ݒ
 */
inline void devSetMaterial(MAT8 *pMat){
	sv3.pDev->SetMaterial(pMat);
}

void devResetMaterial();
void devSetLineMaterial();

/*
 *	XyL[nCCg̎gp
 *
 *	f	: ^l
 */
inline void devSetSpecular(BOOL f){
	devSetState(D3DRS_SPECULARENABLE, f);
}

/*
 *	JO̎gp
 *
 *	f	: ^l
 */
inline void devSetCulling(BOOL f){
	devSetState(D3DRS_CULLMODE, f ? D3DCULL_CCW : D3DCULL_NONE);
}

/*
 *	VF[fBO@
 *
 *	m	: D3DSHADE_GOURAUD, D3DSHADE_FLAT
 */
inline void devSetShading(DWORD m){
	devSetState(D3DRS_SHADEMODE, m);
}

/*
 *	@̎KiXP[OɂVF[fBǑj
 *
 *	f	: ^l
 */
inline void devSetNormalize(BOOL f){
	devSetState(D3DRS_NORMALIZENORMALS, f);
}

/*
 *	Zobt@̃NA
 */
inline void devClearZ(){
	sv3.pDev->Clear(0, NULL, D3DCLEAR_ZBUFFER, 0, 1.0f, 0);
}

/*
 *	Zobt@̎Q
 *
 *	f	: TRUEǍݗLAFALSE
 */
inline void devSetZRead(BOOL f){
	devSetState(D3DRS_ZENABLE, f);
}
inline BOOL devGetZRead(){
	return (BOOL)devGetState(D3DRS_ZENABLE);
}

/*
 *	Zobt@̏
 *
 *	f	: TRUEݗLAFALSE
 *
 *	̂_OƂOFFɂĂ
 */
inline void devSetZWrite(BOOL f){
	devSetState(D3DRS_ZWRITEENABLE, f);
}
inline BOOL devGetZWrite(){
	return (BOOL)devGetState(D3DRS_ZWRITEENABLE);
}

/*
 *	At@eXg̐ݒ
 *
 *	f	: ^l
 *	ref	: Ƃ郿l
 */
inline void devSetAlphaTest(BOOL f, D3DCMPFUNC func, DWORD ref){
	devSetState(D3DRS_ALPHATESTENABLE, f);

	if(f){
		devSetState(D3DRS_ALPHAFUNC, func);
		devSetState(D3DRS_ALPHAREF, ref);
	}
}

#define devALPHA_PASS()	devSetAlphaTest(FALSE, D3DCMP_ALWAYS, 0)
#define devALPHA_GREAT(ref) devSetAlphaTest(TRUE, D3DCMP_GREATEREQUAL, ref)
/*
 *	ufBOt@N^[̐ݒ
 *
 *	flag	: ^l
 *	src		: \[Xl
 *	dst		: fXeBl[Vl
 *
 *	D3DBLEND_SRCALPHA, D3DBLEND_INVSRCALPHA	: uh
 *	D3DBLEND_ONE, D3DBLEND_ONE				: Zuh
 */
inline void devSetBlend(BOOL flag, DWORD src, DWORD dst){
	devSetState(D3DRS_ALPHABLENDENABLE, flag);

	if(flag){
		devSetState(D3DRS_SRCBLEND, src);
		devSetState(D3DRS_DESTBLEND, dst);
	}
}

//	Ȃ
#define devBLEND_NONE() devSetBlend(FALSE, 0, 0)
//	uhiW̔j
#define devBLEND_ALPHA() devSetBlend(TRUE, D3DBLEND_SRCALPHA, D3DBLEND_INVSRCALPHA)
//	xuhi\[X̐F邢قǓj
#define devBLEND_RGB() devSetBlend(TRUE, D3DBLEND_SRCCOLOR, D3DBLEND_INVSRCCOLOR)
//	Zuhi҂̐F̑Zj
#define devBLEND_ADD() devSetBlend(TRUE, D3DBLEND_ONE, D3DBLEND_ONE)
//	Zuhi\[X̃lقǉZj
#define devBLEND_ADD2() devSetBlend(TRUE, D3DBLEND_SRCALPHA, D3DBLEND_ONE)
//	Zuhi}`pXECg}bvȂǂɎgpj
#define devBLEND_MOD() devSetBlend(TRUE, D3DBLEND_DESTCOLOR, D3DBLEND_ZERO)
/*
 *	tHO̐ݒ
 *
 *	flag	: ^l
 *	c		: F
 *	start	: 
 *	end	: Oa
 */
inline void devSetFog(BOOL flag, DWORD c, float start, float end){
	devSetState(D3DRS_FOGENABLE, flag);

	if(flag){
		devSetState(D3DRS_FOGCOLOR,	c);
		devSetState(D3DRS_FOGVERTEXMODE, D3DFOG_LINEAR);
		devSetState(D3DRS_FOGSTART,	*(DWORD *)(&start));
		devSetState(D3DRS_FOGEND,		*(DWORD *)(&end));
	}
}

/*
 *	sNZtHO̐ݒ
 *
 *	flag	: ^l
 *	c		: F
 *	start	: 
 *	end	: Oa
 */
inline void devSetPixelFog(BOOL flag, DWORD c, float start, float end){
	devSetState(D3DRS_FOGENABLE, flag);

	if(flag){
		devSetState(D3DRS_FOGCOLOR,	c);
		devSetState(D3DRS_FOGTABLEMODE, D3DFOG_LINEAR);
		devSetState(D3DRS_FOGSTART,	*(DWORD *)(&start));
		devSetState(D3DRS_FOGEND,	*(DWORD *)(&end));
	}
}
